paths:
  /stackgres/sgclusters:
    get:
      tags:
      - sgcluster
      summary: List sgclusters
      description: |
        List sgclusters and read values from the referenced secrets and configmaps.

        ### RBAC permissions required

        * sgclusters list
        * pod list
        * secrets get
        * configmaps get
      security:
      - JWT: []
    put:
      tags:
      - sgcluster
      summary: Update a sgcluster
      description: |
        Update a sgcluster.

        ### RBAC permissions required

        * sgclusters patch
        * secrets get, create, patch
        * configmaps get, create, patch
      security:
      - JWT: []
    post:
      tags:
      - sgcluster
      summary: Create a sgcluster
      description: |
        Create a sgcluster.
        If values for some script configmap or secret is provided respectively a secret or
         configmap named as the script if name is provided or as the sgcluster with
         `-init-script-<script index>` suffix is created/patched.

        ### RBAC permissions required

        * sgclusters create
        * secrets get, create, patch
        * configmaps get, create, patch
      security:
      - JWT: []
    delete:
      tags:
      - sgcluster
      summary: Delete a sgcluster
      description: |
        Delete a sgcluster.

        ### RBAC permissions required

        * sgclusters delete
      security:
      - JWT: []
  /stackgres/namespaces/{namespace}/sgclusters/{name}/logs:
    get:
      tags:
      - sgcluster
      summary: Get a sgcluster's logs
      description: |
        Get a sgcluster's logs.

        ### RBAC permissions required

        * sgclusters get
        * pod list
      parameters:
      - name: namespace
        description: The namespace to retrieve the resource from
        in: path
        required: true
        schema:
          type: string
      - name: name
        description: The name of the resource to retrieve
        in: path
        required: true
        schema:
          type: string
      - name: records
        description: The number of log entries to return
        in: query
        schema:
          type: integer
          format: int32
      - name: from
        description: |
          The instant in ISO-8601 format (optionally followed by a period and an integer to
           represent a specific `logTimeIndex` value) from which log entries are returned (exclusive).
        in: query
        schema:
          type: string
      - name: to
        description: |
          The instant in ISO-8601 format (optionally followed by a period and an integer to
           represent a specific `logTimeIndex` value) up to which log entries are returned (inclusive).
        in: query
        schema:
          type: string
      - name: sort
        description: The sort order of the returned log entries. Use `asc` for ascending and `desc` for descending.
        in: query
        schema:
          type: string
      - name: text
        description: |
          A query where all terms are separated from a space (` `) character and only are returned
           if all terms are matching. An exact string can be searched if surrounded by a quotes (`"`)
           characters.
        in: query
        schema:
          type: string
      - name: logType
        description: |
          Filter log entries returned by type: `pa` for Patroni; `pg` for Postgres.
        in: query
        schema:
          type: string
      - name: podName
        description: Filter log entries returned by pod name
        in: query
        schema:
          type: string
      - name: role
        description: |
          Filter log entries returned by role: `Primary`, `Replica`, `Uninitialized` or `Standby`
        in: query
        schema:
          type: string
      - name: errorLevel
        description: Filter log entries returned by error level
        in: query
        schema:
          type: string
      - name: userName
        description: Filter log entries returned by user name. This filter works only for Postgres log entries.
        in: query
        schema:
          type: string
      - name: databaseName
        description: Filter log entries returned by database name. This filter works only for Postgres log entries.
        in: query
        schema:
          type: string
      - name: fromInclusive
        description: |
          The instant in ISO-8601 format (optionally followed by a period and an integer to
           represent a specific `logTimeIndex` value) from which log entries are returned (exclusive).
        in: query
        schema:
          type: boolean
      security:
      - JWT: []
  /stackgres/namespaces/{namespace}/sgclusters/{name}/stats:
    get:
      tags:
      - sgcluster
      summary: Get a sgcluster's stats
      description: |
        Get a sgcluster's stats.

        ### RBAC permissions required

        * sgclusters get
        * pod list
        * pod/exec create
      operationId: stats
      parameters:
      - name: namespace
        description: The namespace to retrieve the resource from
        in: path
        required: true
        schema:
          type: string
      - name: name
        description: The name of the resource to retrieve
        in: path
        required: true
        schema:
          type: string
      security:
      - JWT: []
  /stackgres/namespaces/{namespace}/sgclusters/{name}:
    get:
      tags:
      - sgcluster
      summary: Get a sgcluster
      description: |
        Get a sgcluster and read values from the referenced secrets and configmaps.

        ### RBAC permissions required

        * sgclusters get
        * pod list
        * secrets get
        * configmaps get
      parameters:
      - name: namespace
        description: The namespace to retrieve the resource from
        in: path
        required: true
        schema:
          type: string
      - name: name
        description: The name of the resource to retrieve
        in: path
        required: true
        schema:
          type: string
      security:
      - JWT: []
  /stackgres/namespaces/{namespace}/sgclusters/{name}/events:
    get:
      tags:
      - sgcluster
      summary: Get events related to an sgcluster
      description: |
        Get events related to an sgcluster including `StatefulSet`, `Pod`s and `SGDbOps`.

        ### RBAC permissions required

        * events list
        * sgdbops list
      parameters:
      - name: namespace
        description: The namespace to retrieve the resources from
        in: path
        required: true
        schema:
          type: string
      - name: name
        description: The name of the resource the retrieved events are related with
        in: path
        required: true
        schema:
          type: string
      security:
      - JWT: []
